function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React, { forwardRef } from 'react';
import PropTypes from 'prop-types';
import { isFn } from 'js-tool-function';
import ReactEchartsCore from '../Core/EchartsReactCore';
import { titleTextStyle, lbLegend, lbGrid } from '../../itemDefaultConfig';
import Empty from '../Empty';
var AreaChart = /*#__PURE__*/forwardRef(function (_ref, ref) {
  var _ref$config = _ref.config,
      title = _ref$config.title,
      legend = _ref$config.legend,
      series = _ref$config.series,
      grid = _ref$config.grid,
      otherConfig = _objectWithoutProperties(_ref$config, ["title", "legend", "series", "grid"]),
      showTitle = _ref.showTitle,
      showLabel = _ref.showLabel,
      rotate = _ref.rotate,
      cloudData = _ref.cloudData,
      interval = _ref.interval,
      boundaryGap = _ref.boundaryGap,
      setColor = _ref.setColor,
      rest = _objectWithoutProperties(_ref, ["config", "showTitle", "showLabel", "rotate", "cloudData", "interval", "boundaryGap", "setColor"]);

  var targetArr = [];

  var option = _objectSpread({
    title: _objectSpread(_objectSpread({}, titleTextStyle), {}, {
      show: showTitle
    }, title),
    tooltip: {
      trigger: 'item',
      padding: [10, 15],
      textStyle: {
        fontSize: 20
      }
    },
    legend: _objectSpread(_objectSpread({
      top: showTitle ? 27 : 'top'
    }, lbLegend), legend),
    grid: _objectSpread(_objectSpread({
      top: showTitle ? 66 : 36
    }, lbGrid), {}, {
      right: '6%'
    }, grid),
    series: series.map(function (item) {
      targetArr = targetArr.concat(item.data || []);
      return _objectSpread({
        type: 'wordCloud',
        gridSize: 20,
        sizeRange: [12, 50],
        rotationRange: [0, 0],
        shape: 'circle',
        textStyle: {
          normal: {
            color: isFn(setColor) ? setColor : function () {
              return 'rgb(' + Math.round(Math.random() * 255) + ', ' + Math.round(Math.random() * 255) + ', ' + Math.round(Math.random() * 255) + ')';
            }
          },
          emphasis: {
            shadowBlur: 10,
            shadowColor: '#333'
          }
        }
      }, item);
    })
  }, otherConfig);

  if (!targetArr.length) {
    return /*#__PURE__*/React.createElement(Empty, null);
  }

  return /*#__PURE__*/React.createElement(ReactEchartsCore, _extends({
    notMerge: true,
    config: option,
    ref: ref
  }, rest));
});
AreaChart.propTypes = {
  theme: PropTypes.oneOfType([PropTypes.string, PropTypes.object]),
  interval: PropTypes.bool,
  showTitle: PropTypes.bool,
  showLabel: PropTypes.bool,
  style: PropTypes.object,
  className: PropTypes.string,
  config: PropTypes.shape({
    series: PropTypes.array.isRequired
  }).isRequired,
  rotate: PropTypes.number,
  boundaryGap: PropTypes.bool,
  // 是否两边留白
  opts: PropTypes.shape({
    devicePixelRatio: PropTypes.number,
    renderer: PropTypes.oneOf(['canvas', 'svg']),
    width: PropTypes.oneOfType([PropTypes.number, PropTypes.oneOf([null, undefined, 'auto'])]),
    height: PropTypes.oneOfType([PropTypes.number, PropTypes.oneOf([null, undefined, 'auto'])])
  })
};
AreaChart.defaultProps = {
  style: {},
  classname: '',
  theme: 'macarons',
  rotate: 0,
  showTitle: false,
  interval: false,
  showLabel: false,
  boundaryGap: true,
  config: {
    title: {},
    legend: {},
    toolbox: {},
    grid: {},
    series: []
  }
};
export default AreaChart;